function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  it = o[Symbol.iterator]();
  return it.next.bind(it);
}

var classes = {"IndicatorContainer":"_Indicator-module__IndicatorContainer__3I7vF","IndicatorContent":"_Indicator-module__IndicatorContent__3kdsN","Indicators":"_Indicator-module__Indicators__2vhHh","Active":"_Indicator-module__Active__2qRu_"};

function Indicator(_ref) {
  var itemsPerSlide = _ref.itemsPerSlide,
      itemGap = _ref.itemGap,
      children = _ref.children;
  var indicatorsRef = React.useRef(null);
  var itemsRef = React.useRef(null);

  var _useState = React.useState(function () {
    var childrenCount = React__default.Children.count(children);
    return Math.ceil(childrenCount / itemsPerSlide);
  }),
      numberOfIndicators = _useState[0],
      setNumberOfItems = _useState[1];

  var calculateIndicatorDimensions = React.useCallback(function () {
    var childrenCount = React__default.Children.count(children);
    var numberOfIndicators = Math.ceil(childrenCount / itemsPerSlide);

    for (var _iterator = _createForOfIteratorHelperLoose(itemsRef.current.children), _step; !(_step = _iterator()).done;) {
      var item = _step.value;
      item.style.minWidth = Math.ceil(itemsRef.current.offsetWidth / itemsPerSlide) - itemGap + 'px';
      item.style.marginRight = itemGap + 'px';
    }

    setNumberOfItems(numberOfIndicators);
  }, [children, itemGap, itemsPerSlide]);
  React.useEffect(function () {
    window.addEventListener('resize', calculateIndicatorDimensions);
    return function () {
      window.removeEventListener('resize', calculateIndicatorDimensions);
    };
  }, [calculateIndicatorDimensions]);
  React.useEffect(function () {
    calculateIndicatorDimensions();
  }, [calculateIndicatorDimensions]);

  var indicatorChangeHandler = function indicatorChangeHandler(e) {
    var indicatorId = +e.target.dataset.indicator;

    for (var _iterator2 = _createForOfIteratorHelperLoose(indicatorsRef.current.children), _step2; !(_step2 = _iterator2()).done;) {
      var indicator = _step2.value;

      if (indicator.classList.contains(classes.Active)) {
        indicator.classList.remove(classes.Active);
      }
    }

    e.target.classList.add(classes.Active);
    itemsRef.current.style.transform = "translateX(-" + indicatorId * itemsRef.current.offsetWidth + "px)";
  };

  return /*#__PURE__*/React__default.createElement("div", {
    className: classes.IndicatorContainer
  }, /*#__PURE__*/React__default.createElement("div", {
    className: classes.IndicatorContent,
    ref: itemsRef
  }, children), /*#__PURE__*/React__default.createElement("div", {
    className: classes.Indicators,
    ref: indicatorsRef
  }, [].concat(new Array(numberOfIndicators)).map(function (btn, index) {
    return /*#__PURE__*/React__default.createElement("button", {
      key: index,
      className: "" + (index === 0 ? classes.Active : ''),
      "data-indicator": index,
      onClick: indicatorChangeHandler
    });
  })));
}

module.exports = Indicator;
//# sourceMappingURL=index.js.map
